package mux

import (
	"io"

	"git.icedream.tech/icedream/uplink/app/media"
)

type Muxer interface {
	AcceptsCodec(info media.MediaStreamCodecInfo) bool
	GeneratesFormat(info media.MediaStreamContainerInfo) bool

	NewInstance(streams ...*media.MediaStream) <-MuxerInstance
}

type MuxerInstance interface {
	Error() error
	Container() *media.MediaStreamContainerInfo
}
